#ifndef PARTXT_H
#define PARTXT_H

// --8<--8<--8<--8<--
//
// Copyright (C) 2006 Smithsonian Astrophysical Observatory
//
// This file is part of paramxx
//
// paramxx is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// paramxx is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the 
//       Free Software Foundation, Inc. 
//       51 Franklin Street, Fifth Floor
//       Boston, MA  02110-1301, USA
//
// -->8-->8-->8-->8--

#include "ParFileException.h"

/// A class to handle the Param library specific string manipulation
class ParTxt {

  /// This operator outputs the contents of the object.
  friend ostream& operator << ( ostream& os, ParTxt& par ) {
    par.print( os );
    return os;
  }

  /// This operator outputs the contents of the object.
  friend ostream& operator << ( ostream& os, ParTxt* par ) {
    par->print( os );
    return os;
  }
 
public:

  ~ParTxt( );

  ParTxt( char* str=NULL ) throw( ParFileException );

  void init_ParTxt( char* str=NULL ) throw( ParFileException );

  static int restore;

  operator char* ( ) const { return buffer; }

  operator char** ( ) const { return buffer_argv; }

  char* get_token( size_t n ) throw( ParFileException );

  void print( ostream& os );

  static void verify_mode( const string& str ) throw( ParFileException );

protected:

  char*  buffer;

  char** buffer_argv;

  size_t num_tokens;

private:

  ParTxt( const ParTxt& partxt );

  ParTxt& operator = ( const ParTxt& rhs );

};

#endif
