#include <iostream>

using namespace std;

/**
 * A contrived example to demonstrate that stl 
 * uneccessarily calls the copy constructor.
 */
class XXX {

  friend ostream& operator << ( ostream& os, XXX& a ) {
    a.print( os );
    return os;
  }

  friend ostream& operator << ( ostream& os, XXX* a ) {
    a->print( os );
    return os;
  }

  friend bool operator == (const XXX& x1, const XXX& x2) {
    cout << "XXX::operator == ( const XXX&, const XXX& )\n";
    return x1() == x2();
  }

  friend bool operator < (const XXX& x1, const XXX& x2) {
    cout << "XXX::operator < ( const XXX&, const XXX& )\n";
    return x1() < x2();
  }

public:

  static int num_copy;

  static int num_assign;

  ~XXX( ) { cout << "delete XXX( " << val << " )\n"; }

  XXX( int i=0 ) : val( i ) { }

  XXX( const XXX& xx ) {
    cout << "XXX::XXX( const XXX& "  << xx.val << " )\n";
    ++num_copy;
    val = xx.val;
  }

  bool operator()(const char* s1, const char* s2) const {
    return strcmp(s1, s2) == 0;
  }

  int operator ()() const { 
    cout << "XXX::operator()\n";
    return val;
  }

  XXX& operator = ( const XXX& rhs ) {
    ++num_assign;
    val = rhs.val;
    return *this;
  }

  void print( ostream& os ) {
    os << val;
  }

private:

  int val;

};

